unit SecDemoHexEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm2 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button3Click(Sender: TObject);
  private
    function GetOctetString: string;
    procedure SetOctetString(const Value: string);
    { Private declarations }
  public
    property OctetString: string read GetOctetString write SetOctetString;
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

{ TForm2 }

function TForm2.GetOctetString: string;
var
  I, J: Integer;
  H, S: string;
begin
  Result := '';
  for I := 0 to Memo2.Lines.Count - 1 do begin
    H := Memo2.Lines[I];
    S := '';
    if H <> '' then begin
      for J := 0 to ((Length(H) + 2) div 3) - 1 do
        S := S + Char(StrToInt('$' + Copy(H,1 + J*3,2)));
      Result := Result + S;
    end;
  end;
end;

procedure TForm2.SetOctetString(const Value: string);
var
  I: Integer;
  S, H: string;
begin
  Memo1.Lines.Clear;
  Memo2.Lines.Clear;
  S := '';
  H := '';
  for I := 1 to Length(Value) do begin
    if Value[I] < #32 then
      S := S + ' '
    else
      S := S + Value[I];
    H := H + IntToHex(Byte(Value[I]),2) + ' ';
    if I mod 16 = 0 then begin
      Memo1.Lines.Add(S);
      Memo2.Lines.Add(H);
      S := '';
      H := '';
    end;
  end;     
  Memo1.Lines.Add(S);
  Memo2.Lines.Add(H);
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  SetOctetString(GetOctetString);
end;

end.
